package com.cnd3b.common.actionscore;

import com.cnd3b.common.BaseClass;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;

import java.util.HashMap;

/**
 * жϵͳ
 */
public class ActionScore extends BaseClass {

    String siteid = null;
    String createby = null;
    long userid = 0;
    String tagentsid = null;
    String fusertype = null;
    long fsourceid = 0L;
    String fnotes = null;
    fsourcetype fsourcetype = null;
    /**
     * жֵ key:tagentsid,value:tactionscoreid
     */
    protected static HashMap<String, Long> agentactionscoremap = new HashMap<>();
    /**
     * ҵûжֵ key:userid,value:tactionscoreid
     */
    protected static HashMap<Long, Long> usertactionscoremap = new HashMap<>();


    /**
     * жֵ
     */
    protected long getActionScoreID() {
        if ("ҵ".equals(fusertype) && usertactionscoremap.containsKey(userid)) {
            return usertactionscoremap.get(userid);
        } else if ("".equals(fusertype) && agentactionscoremap.containsKey(tagentsid)) {
            return agentactionscoremap.get(tagentsid);
        }

        PaoSetRemote tactionscoreSet = null;
        PaoRemote tactionscore = null;
        try {
            if ("ҵ".equals(fusertype)) {
                tactionscoreSet = getP2ServerSystemPaoSet("tactionscore", "siteid='" + siteid + "' and fusertype='ҵ' and tenterprise_userid='" + userid + "'");
                if (tactionscoreSet.isEmpty()) {
                    tactionscore = tactionscoreSet.addAtEnd();
                    tactionscore.setValue("tenterprise_userid", userid, 11L);
                    tactionscore.setValue("fscore", 0, 11L);
                    tactionscore.setValue("fsitescore", 0, 11L);
                    tactionscore.setValue("fsysscore", 0, 11L);
                    tactionscore.setValue("fusertype", fusertype, 11L);
                    tactionscore.setValue("siteid", siteid, 11L);
                    tactionscoreSet.save();
                } else {
                    tactionscore = tactionscoreSet.getPao(0);
                }
                usertactionscoremap.put(userid, tactionscore.getUniqueIDValue());
            } else if ("".equals(fusertype)) {
                tactionscoreSet = getP2ServerSystemPaoSet("tactionscore", "siteid='" + siteid + "' and fusertype='' and tagentsid='" + tagentsid + "'");
                if (tactionscoreSet.isEmpty()) {
                    tactionscore = tactionscoreSet.addAtEnd();
                    tactionscore.setValue("tagentsid", tagentsid, 11L);
                    tactionscore.setValue("fscore", 0, 11L);
                    tactionscore.setValue("fsitescore", 0, 11L);
                    tactionscore.setValue("fsysscore", 0, 11L);
                    tactionscore.setValue("fusertype", fusertype, 11L);
                    tactionscore.setValue("siteid", siteid, 11L);
                    tactionscoreSet.save();
                } else {
                    tactionscore = tactionscoreSet.getPao(0);
                }
                agentactionscoremap.put(tagentsid, tactionscore.getUniqueIDValue());
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                tactionscoreSet.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        if ("ҵ".equals(fusertype)) {
            return usertactionscoremap.get(userid);
        } else if ("".equals(fusertype)) {
            return agentactionscoremap.get(tagentsid);
        }
        return 0L;
    }


    /**
     * Ӿж
     *
     * @param fscore ֵ
     */
    protected void actionScore_Add(int fscore) {
        if (fscore == 0) {
            return;
        }
        long tactionscoreid = getActionScoreID();
        PaoSetRemote tactionscoreSet = null;
        try {
            tactionscoreSet = getP2ServerSystemPaoSet("tactionscore", "siteid='" + siteid + "' and tactionscoreid=" + tactionscoreid);
            if (!tactionscoreSet.isEmpty()) {
                PaoRemote tactionscore = tactionscoreSet.getPao(0);
                tactionscore.setValue("fscore", tactionscore.getInt("fscore") + fscore, 11L);
                tactionscore.setValue("fsysscore", tactionscore.getInt("fsysscore") + fscore, 11L);
                tactionscore.setValue("fsitescore", tactionscore.getInt("fsitescore") + fscore, 11L);
                PaoSetRemote tactionscoremxSet = tactionscore.getPaoSet("$tactionscoremx", "tactionscoremx");
                String[] ftypemxs = new String[]{"", "ҵ", "ƽ̨"};
                for (String ftypemx : ftypemxs) {
                    PaoRemote tactionscoremx = tactionscoremxSet.addAtEnd();
                    tactionscoremx.setValue("siteid", siteid, 11L);
                    tactionscoremx.setValue("ftype", "", 11L);
                    tactionscoremx.setValue("ftypemx", ftypemx, 11L);
                    tactionscoremx.setValue("fscore", fscore, 11L);
                    tactionscoremx.setValue("fnotes", fnotes, 11L);
                    tactionscoremx.setValue("tactionscoreid", tactionscoreid, 11L);
                    tactionscoremx.setValue("createby", createby, 11L);
                    tactionscoremx.setValue("createdate", getDateTime(), 11L);
                    tactionscoremx.setValue("fsourcetype", fsourcetype.toString(), 11L);
                    tactionscoremx.setValue("fsourceid", fsourceid, 11L);
                }
                tactionscoreSet.save();
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (tactionscoreSet != null) {
                try {
                    tactionscoreSet.close();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }


    /**
     * ۼж
     *
     * @param ftypemx  ҵƽ̨
     * @param fscore   ֵ
     * @param fnotes   ֧˵
     * @param fremarks ע
     */
    protected boolean actionScore_Sub(String ftypemx, int fscore, String fnotes, String fremarks) {
        long tactionscoreid = getActionScoreID();
        PaoSetRemote tactionscoreSet = null;
        try {
            tactionscoreSet = getP2ServerSystemPaoSet("tactionscore", "siteid='" + siteid + "' and tactionscoreid=" + tactionscoreid);
            if (!tactionscoreSet.isEmpty()) {
                PaoRemote tactionscore = tactionscoreSet.getPao(0);
                switch (ftypemx) {
                    case "":
                        tactionscore.setValue("fscore", tactionscore.getInt("fscore") - fscore, 11L);
                        break;
                    case "ҵ":
                        tactionscore.setValue("fsitescore", tactionscore.getInt("fsitescore") - fscore, 11L);
                        break;
                    case "ƽ̨":
                        tactionscore.setValue("fsysscore", tactionscore.getInt("fsysscore") - fscore, 11L);
                        break;
                    default:
                        break;
                }

                PaoSetRemote tactionscoremxSet = tactionscore.getPaoSet("$tactionscoremx", "tactionscoremx");

                PaoRemote tactionscoremx = tactionscoremxSet.addAtEnd();
                tactionscoremx.setValue("siteid", siteid, 11L);
                tactionscoremx.setValue("ftype", "֧", 11L);
                tactionscoremx.setValue("ftypemx", ftypemx, 11L);
                tactionscoremx.setValue("fscore", fscore, 11L);
                tactionscoremx.setValue("fnotes", fnotes, 11L);
                tactionscoremx.setValue("fremarks", fremarks, 11L);
                tactionscoremx.setValue("tactionscoreid", tactionscoreid, 11L);
                tactionscoremx.setValue("createby", createby, 11L);
                tactionscoremx.setValue("createdate", getDateTime(), 11L);

                tactionscoreSet.save();
                return true;
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (tactionscoreSet != null) {
                try {
                    tactionscoreSet.close();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }

        }
        return false;
    }

    public enum fsourcetype {
        /**
         * fsourceidΪ̵ID
         */
        ÿǩ,
        /**
         * fsourceidΪͻӴ¼ID
         */
        ͻ¼,
        /**
         * fsourceidΪͻ¼ID
         */
        ¼,
        /**
         * fsourceidΪ¼ID
         */
        ¼,
        /**
         * fsourceidΪ¼¼ID
         */
        ¼¼,
        /**
         * fsourceidΪǿID
         */
        ǿ,
        /**
         * fsourceidΪͨID
         */
        Ķͨ,
        /**
         * fsourceidΪͨID
         */
        ͨ,
        /**
         * fsourceidΪͨID
         */
        ͨ渽,
        /**
         * fsourceidΪǿID
         */
        Ӫǿ,
        ׼¼,
        ѡ¼,
        г,
        ¼
    }

    public int getScore() {
        if ("".equals(fusertype)) {
            switch (fsourcetype) {
                case ÿǩ:
                    return 10;
                case ͻ¼:
                    return 5;
                case ¼:
                    return 10;
                case ¼:
                    return 5;
                case ¼¼:
                    return 50;
                case ǿ:
                    return 50;
                case Ķͨ:
                    return 5;
                case ͨ:
                    return 10;
                case ͨ渽:
                    return 5;
                case Ӫǿ:
                    return 5;

                default:
                    break;
            }
        } else if ("ҵ".equals(fusertype)) {
            switch (fsourcetype) {
                case ÿǩ:
                    return 10;
                case ׼¼:
                    return 10;
                case ѡ¼:
                    return 5;
                case г:
                    return 50;
                case ¼:
                    return 50;
                case ¼:
                    return 10;
                case Ķͨ:
                    return 5;
                case ͨ:
                    return 10;
                case ͨ渽:
                    return 5;
                case Ӫǿ:
                    return 5;
                default:
                    break;
            }
        }

        return 0;
    }
}
