package com.cnd3b.restcontroller.enterprise.agentclient.mainpage.tagentactivities;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.ArrayList;

public class agentactivities extends Controller {
    public agentactivities(JSONObject content) {
        super(content);
    }

    /**
     * ͳƣҳ򱨣
     *
     * @return
     */
    public String query_analysis() {
        SQLFactory sqlFactory = new SQLFactory(this, "ͳ");
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("tenterprise_userid", userid);
        sqlFactory.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ̻ҿͻбѯ
     *
     * @return
     */
    public String query_agentactivitiesList() {
        /**
         *
         */
        String[] sortfield = {"case when t1.fenddate>getdate() then 1 else 2 end ,t1.checkdate desc"};
        String sort = getSort(sortfield, "case when t1.fenddate>getdate() then 1 else 2 end ,t1.checkdate desc");
        SQLFactory activitiesSQl = new SQLFactory(this, "бѯ", pageSize, pageNumber, sort);
        activitiesSQl.addParameter("siteid", siteid);
        activitiesSQl.addParameter("tagentsid", tagentsid);
        Rows rows = dbConnect.runSqlQuery(activitiesSQl.getSQL());
        ArrayList<String> tagentactivitiesidlist = rows.toArrayList("tagentactivitiesid");

        SQLFactory coverfactory = new SQLFactory(this, "ҿͻҳͼѯ");
        coverfactory.addParameter("siteid", siteid);
        coverfactory.addParameter_in("tagentactivitiesid", tagentactivitiesidlist);
        RowsMap coverrowsmap = dbConnect.runSqlQuery(coverfactory.getSQL()).toRowsMap("tagentactivitiesid");

        for (Row row : rows) {
            String tagentactivitiesid = row.getString("tagentactivitiesid");
            if (coverrowsmap.containsKey(tagentactivitiesid)) {
                row.put("cover", coverrowsmap.get(tagentactivitiesid).get(0).getString("fobsurl"));
            } else {
                row.put("cover", "");
            }
        }
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ̻ҿͻѯ
     *
     * @return
     */
    public String query_agentactivitiesMain() {
        String tagentactivitiesid = content.getString("tagentactivitiesid");//ID
        long tenterprise_userid = content.getLongValue("tenterprise_userid");//ID

        boolean isself = (userid == tenterprise_userid);//ǷΪԼĻ

        SQLFactory activitiesSQl = new SQLFactory(this, isself ? "ҳѯ_" : "ҳѯ_");
        activitiesSQl.addParameter("siteid", siteid);
        activitiesSQl.addParameter("tagentactivitiesid", tagentactivitiesid);
        activitiesSQl.addParameter("tenterprise_userid", userid);

        Rows rows = dbConnect.runSqlQuery(activitiesSQl.getSQL());
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ̻ҿͻѯ_ͳ
     *
     * @return
     */
    public String query_agentactivitiesCustList() {
        long tagentactivitiesid = content.getLongValue("tagentactivitiesid");//ID
        long tenterprise_userid = content.getLongValue("tenterprise_userid");//ID

        boolean isself = (userid == tenterprise_userid);//ǷΪԼĻ

        SQLFactory activitiesSQl = new SQLFactory(this, isself ? "ҳͳƲѯ_" : "ҳͳƲѯ_", pageSize, pageNumber, "t1.createdate desc");
        activitiesSQl.addParameter("siteid", siteid);
        activitiesSQl.addParameter("tagentactivitiesid", tagentactivitiesid);
        activitiesSQl.addParameter("tenterprise_userid", userid);

        Rows rows = dbConnect.runSqlQuery(activitiesSQl.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ̻ҿͻѯ_ͳ
     *
     * @return
     */
    public String query_agentactivitiesFormList() {
        long tagentactivitiesid = content.getLongValue("tagentactivitiesid");//ID
        long tenterprise_userid = content.getLongValue("tenterprise_userid");//ID

        boolean isself = (userid == tenterprise_userid);//ǷΪԼĻ

        SQLFactory activitiesSQl = new SQLFactory(this, isself ? "ҳݲѯ_" : "ҳݲѯ_", pageSize, pageNumber, "t1.createdate desc");
        activitiesSQl.addParameter("siteid", siteid);
        activitiesSQl.addParameter("tagentactivitiesid", tagentactivitiesid);
        activitiesSQl.addParameter("tenterprise_userid", userid);

        Rows rows = dbConnect.runSqlQuery(activitiesSQl.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ޸
     *
     * @return
     */
    public String agentactivitiesInsertOrModify() throws D3bException, P2Exception {
        long tagentactivitiesid = content.getLongValue("tagentactivitiesid");//IDʱĬϴ0
        String ftitle = content.getString("ftitle", "tagentactivities.ftitle", "");//
        String fbegdate = content.getString("fbegdate");//ʼʱ
        String fenddate = content.getString("fenddate");//ʱ
        String fnotes = content.getString("fnotes", "tagentactivities.fnotes", "˵");//˵
        String fphonenumber = content.getString("fphonenumber", "tagentactivities.fphonenumber", "ϵʽ");//ϵʽ


        int fsaler1rewardamount1 = content.getIntValue("fsaler1rewardamount1");//һƹ(λ)
        int fsaler1rewardamount2 = content.getIntValue("fsaler1rewardamount2");//һƹ(λ)
        int fsaler2rewardamount1 = 0;
        if (content.containsKey("fsaler2rewardamount1")) {
            Object o = content.getObject("fsaler2rewardamount1", Integer.class);//ƹ(λ)
            if (o != null) {
                fsaler2rewardamount1 = (int) o;
            }
        }
        int fsaler2rewardamount2 = 0;
        if (content.containsKey("fsaler2rewardamount2")) {
            Object o = content.getObject("fsaler2rewardamount2", Integer.class);//ƹ(λ)
            if (o != null) {
                fsaler2rewardamount1 = (int) o;
            }
        }
        int fupperlimitamount = content.getIntValue("fupperlimitamount");//Ԥ㣨λ֣
        int fnewfreezamount = fupperlimitamount;//
        Rows checkrows = dbConnect.runSqlQuery("select * from tagentactivities where siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tagentactivitiesid='" + tagentactivitiesid + "'");
        if (!checkrows.isEmpty()) {
            int fusedamount = checkrows.get(0).getInteger("fusedamount");
            int foldupperlimitamount = checkrows.get(0).getInteger("fupperlimitamount");
            String fstatus = checkrows.get(0).getString("fstatus");
            if ("ѽ".equals(fstatus)) {
                return getErrReturnObject().setErrMsg("ѽ޸ģ").toString();
            } else if (fupperlimitamount < fusedamount) {
                return getErrReturnObject().setErrMsg("Ԥ㲻Сʹý").toString();
            }
            if (fupperlimitamount > foldupperlimitamount) {
                fnewfreezamount = fupperlimitamount - foldupperlimitamount;
            }
        }
        //
        if (getUserCanUseAmount() < fnewfreezamount) {
            return getErrReturnObject().setErrMsg("˻㣡").toString();
        }

        PaoSetRemote tagentactivitiesSet = getP2ServerSystemPaoSet("tagentactivities", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tagentactivitiesid='" + tagentactivitiesid + "'");
        PaoRemote tagentactivities = null;
        if (tagentactivitiesid <= 0 || tagentactivitiesSet.isEmpty()) {
            tagentactivities = tagentactivitiesSet.addAtEnd();
            tagentactivities.setValue("siteid", siteid, 11L);//ҵID
            tagentactivities.setValue("tenterprise_userid", userid, 11L);//ûID
            tagentactivities.setValue("createby", username, 11L);//¼
            tagentactivities.setValue("createdate", sysdate, 11L);//¼ʱ
            tagentactivities.setValue("fstatus", "ƹ", 11L);//ƹز״̬
            tagentactivities.setValue("tagentsid", tagentsid, 11L);
            tagentactivities.setValue("fusedamount", 0, 11L);

            tagentactivitiesid = tagentactivities.getLong("tagentactivitiesid");
        } else {
            tagentactivities = tagentactivitiesSet.getPao(0);
        }
        tagentactivities.setValue("ftitle", ftitle, 11L);
        tagentactivities.setValue("fbegdate", fbegdate, 11L);
        tagentactivities.setValue("fenddate", fenddate, 11L);

        tagentactivities.setValue("fsaler1rewardamount1", fsaler1rewardamount1, 11L);
        tagentactivities.setValue("fsaler1rewardamount2", fsaler1rewardamount2, 11L);
        tagentactivities.setValue("fsaler2rewardamount1", fsaler2rewardamount1, 11L);
        tagentactivities.setValue("fsaler2rewardamount2", fsaler2rewardamount2, 11L);
        tagentactivities.setValue("fupperlimitamount", fupperlimitamount, 11L);

        tagentactivities.setValue("fnotes", fnotes, 11L);
        tagentactivities.setValue("fphonenumber", fphonenumber, 11L);

        tagentactivities.setValue("checkby", username, 11L);//¼
        tagentactivities.setValue("checkdate", sysdate, 11L);//¼ʱ
        tagentactivities.setValue("changeby", username);//޸
        tagentactivities.setValue("changedate", sysdate);//޸ʱ

        content.put("tagentactivitiesid", tagentactivitiesid);
        content.put("tenterprise_userid", userid);
        saveDataLog(tagentactivities);
        tagentactivitiesSet.save();

        return query_agentactivitiesMain();
    }

    /**
     * ̻¼
     *
     * @return
     */
    public String agentactivitiesShare() throws P2Exception {
        long tagentactivitiesid = content.getLongValue("tagentactivitiesid");//ID

        PaoSetRemote tagentactivities_shareSet = getP2ServerSystemPaoSet("tagentactivities_share");
        PaoRemote tagentactivities_share = tagentactivities_shareSet.addAtEnd();
        tagentactivities_share.setValue("siteid", siteid, 11L);//ҵID
        tagentactivities_share.setValue("fsaler1id", userid, 11L);//һƹID
        tagentactivities_share.setValue("fsaler1", username, 11L);//һƹ
        tagentactivities_share.setValue("tagentactivitiesid", tagentactivitiesid, 11L);
        tagentactivities_share.setValue("createdate", getDateTime(), 11L);//ƹʱ
        long tagentactivities_shareid = tagentactivities_share.getUniqueIDValue();
        tagentactivities_shareSet.save();

        JSONObject dataobject = new JSONObject();
        dataobject.put("tagentactivities_shareid", tagentactivities_shareid);
        return getSucReturnObject().setData(dataobject).toString();
    }

}
