select SUM(t.fnewcustcount)    as fnewcustcount,
       SUM(fnewreceptioncount) as fnewreceptioncount,
       SUM(t.fnewordercount)   as fnewordercount,
       SUM(t.favgorderamount)  as favgorderamount,
       SUM(t.freturncount)     as freturncount
from (
         select count(0) as fnewcustcount,
                0        as fnewreceptioncount,
                0        as fnewordercount,
                0        as favgorderamount,
                0        as freturncount
         from tcustomer t1
         where siteid = $siteid$
           and tagentsid = $tagentsid$
           and convert(varchar(7), createdate, 120) = $fdate$
         union all
         select 0        as fnewcustcount,
                count(0) as fnewreceptioncount,
                0        as fnewordercount,
                0        as favgorderamount,
                0        as freturncount
         from tcustomer_reception t1
         where siteid = $siteid$
           and tagentsid = $tagentsid$
           and convert(varchar(7), createdate, 120) = $fdate$ and $where$
         union all
         select 0                                          as fnewcustcount,
                0                                          as fnewreceptioncount,
                count(0)                                   as fnewordercount,
                convert(int, isnull(AVG(forderamount), 0)) as favgorderamount,
                0                                          as freturncount
         from tcustomer_reception t1
         where siteid = $siteid$
           and tagentsid = $tagentsid$
           and ftype = ''
           and convert(varchar(7), createdate, 120) = $fdate$ and $where$
         union all
         select 0        as fnewcustcount,
                0        as fnewreceptioncount,
                0        as fnewordercount,
                0        as favgorderamount,
                count(0) as freturncount
         from tcustomer_reception t1
         where siteid = $siteid$
           and tagentsid = $tagentsid$
           and ftype = ''
           and fstatus = '˵'
           and convert(varchar(7), closedate, 120) = $fdate$ and $where$
     ) t