package com.cnd3b.restcontroller.enterprise.salerwebclient.mainpage.data;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;

import java.text.SimpleDateFormat;
import java.util.Calendar;
public class analysis extends Controller {

    public analysis(JSONObject content) {
        super(content);
    }


    /**
     * 
     * <p>
     * ҵԱ
     *
     * @return
     */
    public String businesstripGrade() {
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());
            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory factory = new SQLFactory(this, "_ҵԱ");
        factory.addParameter("siteid", siteid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        factory.addParameter("fbegmonth", fbegmonth);
        factory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * 
     * <p>
     * ռ
     *
     * @return
     */
    public String businesstripGetKnowledge() {
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());
            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory factory = new SQLFactory(this, "_̷ռ");
        factory.addParameter("siteid", siteid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        factory.addParameter("fbegmonth", fbegmonth);
        factory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * 
     * <p>
     * ͬ
     *
     * @return
     */
    public String saleAmountGrowthRateAnalysis() {
        int fyear = content.getIntValue("fyear");
        int fmonth = content.getIntValue("fmonth");

        SQLFactory factory = new SQLFactory(this, "_ͬ");
        factory.addParameter("siteid", siteid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        factory.addParameter("fyear", fyear);
        factory.addParameter("fmonth", fmonth);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        RowsMap map = rows.toRowsMap("fclass");

        String[] fclasses = {"-20%", "20%-0", "0-10%", "10-20%", "20%"};
        JSONArray array = new JSONArray();
        for (String fclass : fclasses) {
            JSONObject object = new JSONObject();
            object.put("fclass", fclass);
            object.put("fcount", map.get(fclass).size());
            object.put("fdata", map.get(fclass));
            array.add(object);
        }
        return getSucReturnObject().setData(array).saveToDataPool().toString();
    }

    /**
     * 
     * <p>
     * ƽ
     *
     * @return
     */
    public String saleAmountAverageAnalysis() {
        int fyear = content.getIntValue("fyear");
        SQLFactory factory = new SQLFactory(this, "_ƽ");
        factory.addParameter("siteid", siteid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        factory.addParameter("fyear", fyear);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        RowsMap map = rows.toRowsMap("fclass");

        String[] fclasses = {"1w", "1-3w", "3-5w", "5-10w", "10-20w", "20-50w", "50-100w", "100w"};
        JSONArray array = new JSONArray();
        for (String fclass : fclasses) {
            JSONObject object = new JSONObject();
            object.put("fclass", fclass);
            object.put("fcount", map.get(fclass).size());
            object.put("fdata", map.get(fclass));
            array.add(object);
        }
        return getSucReturnObject().setData(array).saveToDataPool().toString();
    }

    /**
     * 
     * <p>
     * ݷ
     *
     * @return
     */
    public String saleAmountAnalysis() {
        int fyear = content.getIntValue("fyear");
        int fmonth = content.getIntValue("fmonth");
        SQLFactory factory = new SQLFactory(this, "_ݷ");
        factory.addParameter("siteid", siteid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        factory.addParameter("fyear", fyear);
        factory.addParameter("fmonth", fmonth);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * 
     * <p>
     * ռȷ
     *
     * @return
     */
    public String storeAreaAnalysis() {
        SQLFactory factory = new SQLFactory(this, "_ռȷ");
        factory.addParameter("siteid", siteid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        RowsMap map = rows.toRowsMap("fclass");

        String[] fclasses = {"<60", "60-80", "80-100", "100-150", "150-200", "200-300", ">300"};
        JSONArray array = new JSONArray();
        for (String fclass : fclasses) {
            JSONObject object = new JSONObject();
            object.put("fclass", fclass);
            object.put("fcount", map.get(fclass).size());
            object.put("fdata", map.get(fclass));
            array.add(object);
        }
        JSONObject object = new JSONObject();
        object.put("data", array);

        SQLFactory factory2 = new SQLFactory(this, "_ƽ");
        factory2.addParameter("siteid", siteid);
        factory2.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows2 = dbConnect.runSqlQuery(factory2.getSQL());
        if (rows2.isEmpty()) {
            object.put("favgarea", 0);
        } else {
            object.put("favgarea", rows2.get(0).getDouble("farea"));
        }
        return getSucReturnObject().setData(object).saveToDataPool().toString();
    }

    /**
     * 
     * <p>
     * Ľ
     *
     * @return
     */
    public String storeRebuildAnalysis() {
        String[] salers = getSubUsers();
        SQLFactory factory = new SQLFactory(this, "_̸Ľ");
        factory.addParameter("siteid", siteid);
        factory.addParameter_in("tenterprise_userid", salers);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        RowsMap map = rows.toRowsMap("fclass");
        String[] fclasses = {"<3", "<2", "<1"};
        JSONArray array = new JSONArray();
        for (String fclass : fclasses) {
            JSONObject object = new JSONObject();
            object.put("fclass", fclass);
            object.put("fcount", map.get(fclass).size());
            object.put("fdata", map.get(fclass));
            array.add(object);
        }

        JSONObject object = new JSONObject();
        object.put("data", array);

        SQLFactory factory2 = new SQLFactory(this, "_ƽʱ");
        factory2.addParameter("siteid", siteid);
        factory2.addParameter_in("tenterprise_userid", salers);
        Rows rows2 = dbConnect.runSqlQuery(factory2.getSQL());
        if (rows2.isEmpty()) {
            object.put("favgintervaltime", 0);
        } else {
            object.put("favgintervaltime", rows2.get(0).getDouble("intervaltime"));
        }

        return getSucReturnObject().setData(object).saveToDataPool().toString();
    }

    /**
     * 
     * <p>
     * 
     *
     * @return
     */
    public String storeMarketAnalysis() {
        SQLFactory factory = new SQLFactory(this, "_");
        factory.addParameter("siteid", siteid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        RowsMap map = rows.toRowsMap("fclass");

        String[] fclasses = dbConnect.runSqlQuery("select fvalue from ttypedetail where ftype=''").toArray("fvalue");
        JSONArray array = new JSONArray();
        for (String fclass : fclasses) {
            JSONObject object = new JSONObject();
            object.put("fclass", fclass);
            object.put("fcount", map.get(fclass).size());
            object.put("fdata", map.get(fclass));
            array.add(object);
        }

        return getSucReturnObject().setData(array).saveToDataPool().toString();
    }

    /**
     * 
     * <p>
     * ̵
     *
     * @return
     */
    public String agentList() {
        SQLFactory factory = new SQLFactory(this, "_̵", pageSize, pageNumber, "fagentnum");
        factory.addParameter("siteid", siteid);
        factory.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * 
     * <p>
     * ̵,б
     *
     * @return
     */
    public String agentStoreList() {
        SQLFactory factory = new SQLFactory(this, "_̵б");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tagentsid", content.getString("tagentsid"));
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ն˴
     * ͻ
     * ͻԴͼ
     *
     * @return
     */
    public String channelofcustomers() {
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");

        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }

        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_ͻ_ͻԴ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ն˴
     * ͻ
     * ͻ˫ֵ״ͼ
     *
     * @return
     */
    public String newcustomers() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_ͻ_ͻ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }


    /**
     * ն˴
     * ͻ
     * ۶©ͼ
     *
     * @return
     */
    public String customeraction() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }

        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_ͻ_۶");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }


    /**
     * ն˴
     * ͻ
     * <p>
     * ͼ
     *
     * @return
     */
    public String channeloforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_ͻ_");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ն˴
     * ͻ
     * <p>
     * ɽƷ״ͼ
     *
     * @return
     */
    public String productoforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }

        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_ͻ_ɽƷ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ն˴
     * ͻ
     * <p>
     * ̶ռȷ
     *
     * @return
     */
    public String agentsoforders() {
        String sort = "count(t1.tagentsid) desc";
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_ͻ_̶ռȷ", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }


    /**
     * ն˴
     * ͻ
     * <p>
     * ͵ֵͼ
     *
     * @return
     */
    public String amountoforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_ͻ_͵ֵ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }


    /**
     * ն˴
     * ͻ
     * <p>
     * Сռȷͼ
     *
     * @return
     */
    public String communityoforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_ͻ_Сռȷ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ն˴
     * ͻ
     * <p>
     * ˵ʷͼ
     *
     * @return
     */
    public String returncountoforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_ͻ_˵ʷ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }


    /**
     * ն˴
     * ͻ
     * <p>
     * 
     *
     * @return
     */
    public String customeroforders() {
        /**
         *
         */
        String[] sortfield = {"t1.fdate"};
        String sort = getSort(sortfield, "t1.fdate desc");

        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_ͻ_", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }


    /**
     * ն˴
     * ¼
     * <p>
     * ¼ռȷͼ
     *
     * @return
     */
    public String eventoforders() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_¼_¼ռȷ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ն˴
     * ¼
     * <p>
     * ۼ¼ͳƷͼ
     *
     * @return
     */
    public String eventofagentorders() {
        String sort = "count(distinct tsaleeventid) desc";
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_¼_ۼ¼ͳƷ", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ն˴
     * ¶ȷ÷
     * <p>
     * ¶÷ͼ
     *
     * @return
     */
    public String costnameofmonth() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_¶ȷ÷_¶÷");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }


    /**
     * ն˴
     * ¶ȷ÷
     * <p>
     * ¶ӯͼ
     *
     * @return
     */
    public String costandordersofmonth() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_¶ȷ÷_¶ӯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }


    /**
     * ն˴
     * ͻ
     * <p>
     * Ͽͻ
     *
     * @return
     */
    public String oldcustomer() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_ͻ_Ͽͻ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        sqlFactory.addParameter("pageNumber", pageNumber);
        sqlFactory.addParameter("pageSize", pageSize);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        returnObject = getSucReturnObject().setData(rows);
        returnObject.put("pageNumber", pageNumber);
        returnObject.put("pageSize", pageSize);
        returnObject.put("total", rows.getTotalRows());
        returnObject.put("pageTotal", rows.getTotalPage());
        DataPool.put(content.toString(), returnObject);
        return returnObject.toString();
    }


    /**
     * ն˴
     * ͻ
     * <p>
     * ͻ
     *
     * @return
     */
    public String newcustomer() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_ͻ_ͻ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        sqlFactory.addParameter("pageNumber", pageNumber);
        sqlFactory.addParameter("pageSize", pageSize);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        returnObject = getSucReturnObject().setData(rows);
        returnObject.put("pageNumber", pageNumber);
        returnObject.put("pageSize", pageSize);
        returnObject.put("total", rows.getTotalRows());
        returnObject.put("pageTotal", rows.getTotalPage());
        DataPool.put(content.toString(), returnObject);
        return returnObject.toString();
    }


    /**
     * Ӵ׵ɽͼ
     *
     * @return
     */
    public String receptiontimesoffirstorder() {
        //Ϊ0Ĭȡǰǰ12µ
        String fbegmonth = content.getString("fbegmonth");
        String fendmonth = content.getString("fendmonth");
        if ("".equals(fbegmonth) || "".equals(fendmonth)) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM");
            fbegmonth = format.format(calendar.getTime());

            calendar.add(Calendar.MONTH, -11);
            fendmonth = format.format(calendar.getTime());
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ն˴_ͻ_Ӵɽ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", getSubUsers());
        sqlFactory.addParameter("fbegmonth", fbegmonth);
        sqlFactory.addParameter("fendmonth", fendmonth);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }
}