select t1.tenterprise_userid,
       t3.fname                                           fsaler,
       t1.fname,
       t2.fprovince,
       t2.fcity,
       t2.fcounty,
       t1.fphonenumber,
       MAX(t4.createdate) as                              flastreadtime,
       count(distinct t4.tarchives_userdaid)              freadcount,
       sum(DATEDIFF(MINUTE, t4.createdate, t4.closedate)) freadtimes
from tenterprise_users t1
         inner join tagents t2 on t1.siteid = t2.siteid and t1.tagentsid = t2.tagentsid
         inner join tenterprise_users t3 on t2.siteid = t3.siteid and t2.fsaleruserid = t3.tenterprise_userid
         left join tarchives_userdata t4
                    on t1.siteid = t4.siteid and t1.tenterprise_userid = t4.tenterprise_userid and t4.tarchivesid =$tarchivesid$
where t1.siteid = $siteid$  and t1.fisadministrator=1 and t1.fusertype = ''
  and not exists (
    select tenterprise_userid from tattachment
    inner join tattachment_downlog on tattachment.siteid=tattachment_downlog.siteid
  and tattachment.tattachmentid=tattachment_downlog.tattachmentid
    where tattachment.siteid=t1.siteid
  and tattachment.ownertable='tarchives'
  and tattachment.ownerid=$tarchivesid$
  and tattachment_downlog.tenterprise_userid=t1.tenterprise_userid
    )
group by t1.tenterprise_userid, t3.fname, t1.fname, t2.fprovince, t2.fcity, t2.fcounty, t1.fphonenumber