package com.cnd3b.restcontroller.enterprise.webclient.phonebook;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

public class phonebook extends Controller {

    public phonebook(JSONObject content) {
        super(content);
    }

    public String query() {
        /**
         *
         */
        String[] sortfield = {"t1.fgroupname", "t1.fdepname"};
        String sort = getSort(sortfield, "t1.fgroupname,t1.fdepname");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.fname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fdepname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.frole like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fgroupname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fphonenumber like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
        }
        SQLFactory costhead = new SQLFactory(this, "ͨѶ¼ѯ");
        costhead.addParameter("siteid", siteid);
        costhead.addParameter_SQL("where", where);

        RowsMap rowsMap = dbConnect.runSqlQuery(costhead.getSQL()).toRowsMap("fgroupname");
        JSONArray returnarray = new JSONArray();
        for (String key : rowsMap.keySet()) {
            Rows rows = rowsMap.get(key);
            JSONObject object = new JSONObject();
            object.put("fgroupname", key);
            object.put("phonebooklist", rows.toJsonArray());

            returnarray.add(object);
        }
        return getSucReturnObject().setData(returnarray).saveToDataPool().toString();
    }

    /**
     * ͨѶ¼޸
     *
     * @return
     */
    public String insertOrModify() throws D3bException, P2Exception {
        long tenterprise_phonid = content.getLongValue("tenterprise_phonid"); //ʱĬϴ0
        String fname = content.getString("fname", "tenterprise_phonebook.fname", "");//
        String fdepname = content.getString("fdepname", "tenterprise_phonebook.fdepname", "");//
        String frole = content.getString("frole", "tenterprise_phonebook.frole", "ְ");//ɫ
        String fphonenumber = content.getString("fphonenumber", "tenterprise_phonebook.fphonenumber", "ֻ");//ֻ
        String fgroupname = content.getString("fgroupname");//

        PaoSetRemote tenterprise_phonebookSet = getP2ServerSystemPaoSet("tenterprise_phonebook", "siteid='" + siteid + "' and tenterprise_phonid='" + tenterprise_phonid + "'");
        PaoRemote tenterprise_phonebook = null;
        if (tenterprise_phonid <= 0 || tenterprise_phonebookSet.isEmpty()) {
            tenterprise_phonebook = tenterprise_phonebookSet.addAtEnd();
            tenterprise_phonebook.setValue("siteid", siteid, 11L);//ҵID
            tenterprise_phonebook.setValue("createby", username, 11L);//¼
            tenterprise_phonebook.setValue("createdate", sysdate, 11L);//¼ʱ
        } else {
            tenterprise_phonebook = tenterprise_phonebookSet.getPao(0);
        }
        tenterprise_phonebook.setValue("fname", fname, 11L);//
        tenterprise_phonebook.setValue("fdepname", fdepname, 11L);//
        tenterprise_phonebook.setValue("frole", frole, 11L);//ɫ
        tenterprise_phonebook.setValue("fphonenumber", fphonenumber, 11L);//ֻ
        tenterprise_phonebook.setValue("fgroupname", fgroupname, 11L);//
        tenterprise_phonebook.setValue("changeby", username, 11L);//޸
        tenterprise_phonebook.setValue("changedate", sysdate, 11L);//޸ʱ
        saveDataLog(tenterprise_phonebook);
        tenterprise_phonebookSet.save();

        return getSucReturnObject().toString();
    }

    /**
     * ͨѶ¼ɾ
     *
     * @return
     */
    public String delete() {
        SQLFactory sqlFactory = new SQLFactory(this, "ͨѶ¼ɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tenterprise_phonid", content.getLongValue("tenterprise_phonid"));

        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }


    /**
     * Աбѯ
     *
     * @return
     */
    public String query_groupnameList() {
        SQLFactory sql = new SQLFactory(this, "ͨѶ¼ѯ");
        sql.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * Ա޸
     *
     * @return
     */
    public String insert_modify_groupname() throws D3bException, P2Exception {
        long ttypedetailid = content.getLongValue("ttypedetailid");//Ϊ0
        String fgroupname = content.getString("fgroupname", "ttypedetail.fvalue", "ͨѶ¼");
        boolean fisused = content.getBooleanValue("fisused");

        Rows rows = dbConnect.runSqlQuery("select * from ttypedetail where siteid='" + siteid + "' and ftype='ͨѶ¼Ա' and fvalue='" + fgroupname + "'");
        if (!rows.isEmpty() && rows.get(0).getLong("ttypedetailid") != ttypedetailid) {
            return getErrReturnObject().setErrMsg("ͨѶ¼Ա಻ظ").toString();
        }

        PaoSetRemote ttypedetailSet = getP2ServerSystemPaoSet("ttypedetail", "siteid='" + siteid + "' and ttypedetailid='" + ttypedetailid + "'");
        PaoRemote ttypedetail = null;
        if (ttypedetailSet.isEmpty()) {
            ttypedetail = ttypedetailSet.addAtEnd();
            ttypedetail.setValue("siteid", siteid, 11L);//ҵID
            ttypedetail.setValue("ftype", "ͨѶ¼Ա", 11L);
        } else {
            ttypedetail = ttypedetailSet.getPao(0);
        }
        ttypedetail.setValue("fvalue", fgroupname, 11L);
        ttypedetail.setValue("fisused", fisused, 11L);
        ttypedetailSet.save();

        return getSucReturnObject().toString();
    }

    /**
     * Դɾ
     *
     * @return
     */
    public String delete_groupname() {
        SQLFactory sqlFactory = new SQLFactory(this, "ͨѶ¼ɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("ttypedetailid", content.getLongValue("ttypedetailid"));
        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }
}
