package com.cnd3b.restcontroller.singleagent.webclient.data;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.db.DBConnect;

import java.util.ArrayList;
import java.util.Calendar;

public class DataTips {
    JSONObject tipsobject = null;
    Rows datarows = null;
    String type = null;

    public DataTips(Rows datarows, String type) {
        tipsobject = new JSONObject();
        this.datarows = datarows;
        this.type = type;
    }

    public DataTips(String type) {
        tipsobject = new JSONObject();
        this.type = type;
    }

    public JSONObject getTips() {
        switch (type) {
            case "ͻԴ":
                return createTips1();
            case "ͻ":
                return createTips2();
            case "۶":
                return createTips3();
            case "":
                return createTips4();
            case "ɽƷ":
                return createTips5();
            case "͵ֵ":
                return createTips6();
            case "Сռȷ":
                return createTips7();
            case "Сȷ":
                return createTips16();
            case "˵ʷ":
                return createTips8();
            case "":
                return createTips9();
            case "¼ռȷ":
                return createTips10();
            case "¶÷":
                return createTips11();
            case "¶ӯ":
                return createTips12();
            case "ϿͻϢ":
                return createTips13();
            case "Ͽͻάϵͳ":
                return createTips18();
            case "Ͽͻάϵͳ":
                return createTips19();
            case "ͻϢ":
                return createTips14();
            case "ͻϵͳ":
                return createTips17();
            case "Ӵɽ":
                return createTips15();
            default:break;
        }
        return null;
    }

    /**
     * ͻԴ
     * """"3ϵĶʱŷؽ顣
     *
     * @return
     */
    public JSONObject createTips1() {
        ArrayList<Row> fchannelList = new ArrayList<>();
        for (Row datarow : datarows) {
            if (!",".contains(datarow.getString("fchannel"))) {
                fchannelList.add(datarow);
            }
        }
        if (fchannelList.size() >= 3) {
            String fchannel1 = fchannelList.get(0).getString("fchannel");
            String fchannel2 = fchannelList.get(1).getString("fchannel");
            tipsobject.put("Դ", "Ӵ¼");
            tipsobject.put("ؼ", "ǿ" + fchannel1 + "ǿ" + fchannel2);
            tipsobject.put("ͼƬ", "עռȽС");
            tipsobject.put("ų", "ռռȲΪο");
            tipsobject.put("Բο", fchannel1 + "" + fchannel2 + "Ҫǿ磬ԴԺ");
        }
        return tipsobject;
    }

    /**
     * ͻ
     * ǰµӴͻǷڵǰµѹΪǰÿ1㣩
     *
     * @return
     */
    public JSONObject createTips2() {
        if (datarows.size() > 0) {
            int fcount = 0;//ǰµͻ
            for (Row datarow : datarows) {
                if (datarow.getInteger("fmonth") == Calendar.getInstance().get(Calendar.MONTH)) {
                    fcount = fcount + datarow.getInteger("fcount");
                }
            }
            boolean fispass = (fcount >= Calendar.getInstance().get(Calendar.DAY_OF_MONTH));
            tipsobject.put("Դ", "Ӵ¼");
            tipsobject.put("ؼ", fispass ? " Ŭ" : "");
            tipsobject.put("ͼƬ", "ƽ̨Ļͻ30/£1/죩");
            tipsobject.put("ų", "");
            tipsobject.put("Բο", "ڵµͻ" + (fispass ? ">=ͱ׼ֵ꣬Ŭ" : "<ͱ׼"));
        }
        return tipsobject;
    }

    /**
     * ۶
     *
     * @return
     */
    public JSONObject createTips3() {
        if (datarows.size() >= 3) {
            String fcustaction = ""; //ڽ׶
            int fcount = 0;
            for (int i = 0; i < datarows.size() - 1; i++) {
                int newcount = datarows.get(i).getInteger("fcount") - datarows.get(i + 1).getInteger("fcount");
                if (newcount > fcount) {
                    fcustaction = datarows.get(i + 1).getString("fcustaction");
                    fcount = newcount;
                }
            }
            if (!"".equals(fcustaction)) {
                if ("".equals(fcustaction)) {
                    tipsobject.put("ؼ", "ע ǿ");
                    tipsobject.put("Բο", "ڵµļ΢׶ʧ󣬼ǿ࿪չ¼ÿͻ");
                } else if ("".equals(fcustaction)) {
                    tipsobject.put("ؼ", " ֪ʶ");
                    tipsobject.put("Բο", "ڵµĽ½׶ʧǿͻɽǰıؾҪרҵ֪ʶ");
                } else if ("".equals(fcustaction)) {
                    tipsobject.put("ؼ", " Ҫǿ");
                    tipsobject.put("Բο", "ڵµƽ׶ʧǿͻɽĹؼ裬ͻƷ");
                } else if ("ɽ".equals(fcustaction)) {
                    tipsobject.put("ؼ", "ע ");
                    tipsobject.put("Բο", "ڵµɽ׶ʧпܿͻƲ⵼³ɽʵͣصˮƽ");
                }
                tipsobject.put("Դ", "¼");
                tipsobject.put("ų", "");
                tipsobject.put("ͼƬ", "ڶ֮䣬ٷֱȿֵжϵԳɽΪ");
            }
        }
        return tipsobject;
    }

    /**
     * 
     *
     * @return
     */
    public JSONObject createTips4() {
        ArrayList<Row> fchannelList = new ArrayList<>();
        for (Row datarow : datarows) {
            if (!",".contains(datarow.getString("fchannel"))) {
                fchannelList.add(datarow);
            }
        }
        if (fchannelList.size() >= 3) {
            String fchannel1 = fchannelList.get(0).getString("fchannel");
            String fchannel2 = fchannelList.get(1).getString("fchannel");
            tipsobject.put("Դ", "¼");
            tipsobject.put("ؼ", "ǿ" + fchannel1 + "ǿ" + fchannel2);
            tipsobject.put("ͼƬ", "עռȽС");
            tipsobject.put("ų", "ռռȲΪο");
            tipsobject.put("Բο", fchannel1 + "" + fchannel2 + "Ҫǿ磬ԴԺ");
        }
        return tipsobject;
    }

    /**
     * ɽƷ
     *
     * @return
     */
    public JSONObject createTips5() {
        if (datarows.size() >= 3) {
            String fprodname = datarows.get(0).getString("fprodname");
            tipsobject.put("Դ", "¼");
            tipsobject.put("ؼ", fprodname + " ë");
            tipsobject.put("ͼƬ", "עߵĲƷ");
            tipsobject.put("ų", "");
            tipsobject.put("Բο", fprodname + "ߣëͬʱͨͬ͡۸Ʒеķʽë");
        }
        return tipsobject;
    }

    /**
     * ͵ֵ
     *
     * @return
     */
    public JSONObject createTips6() {
        if (datarows.size() >= 2) {
            double famount1 = datarows.get(datarows.size() - 1).getDouble("famount");
            double famount2 = datarows.get(datarows.size() - 2).getDouble("famount");
            if (famount1 > famount2) {
                tipsobject.put("ؼ", "͵ֵ Ŭ");
                tipsobject.put("Բο", "µĿ͵ֵͬŬ");
            } else {
                tipsobject.put("ؼ", "͵ֵ» Ҫ");
                tipsobject.put("Բο", "µĿ͵ֵͬ»ԭ͵ֵ");
            }
            tipsobject.put("Դ", "¼");
            tipsobject.put("ͼƬ", "ͬƽ͵ֵΪ");
            tipsobject.put("ų", "");
        }
        return tipsobject;
    }

    /**
     * Сռȷ
     *
     * @return
     */
    public JSONObject createTips7() {
        if (datarows.size() >= 3) {
            tipsobject.put("Դ", "¼");
            tipsobject.put("ؼ", "ѡССΣĿ͵ֵ");
            tipsobject.put("ͼƬ", "СɽԼСɽռάΪ");
            tipsobject.put("ų", "");
            tipsobject.put("Բο", "ежɽСǷѡС͵ֵжСԼ趨Ŀ͵ֵ");
        }
        return tipsobject;
    }

    /**
     * Сȷ
     *
     * @return
     */
    public JSONObject createTips16() {
        if (datarows.size() >= 3) {
            tipsobject.put("Դ", "¼");
            tipsobject.put("ؼ", "ݿͻСƼƷ");
            tipsobject.put("ͼƬ", "ͻƼƷ뱨ʱע3άȣͿ͵ֵ߿͵ֵƽ͵ֵСɽжϸСǷǱ");
            tipsobject.put("ų", "");
            tipsobject.put("Բο", "ƼͻĲƷ뱨ۣǸݿͻСԼ͵ֵΪݣͻı۾СͿ͵ֵС߿͵ֵ");
        }
        return tipsobject;
    }

    /**
     * ͻϵͳ
     *
     * @return
     */
    public JSONObject createTips17() {
        tipsobject.put("Դ", "Ӵ¼");
        tipsobject.put("ؼ", "ĿͻѾܾûˣʱ");
        tipsobject.put("ͼƬ", "Ϊݣ714ûü¼ͻϵͳϵͳʾѣͼеĿͻ");
        tipsobject.put("ų", "");
        tipsobject.put("Բο", "ϽͼеĿͻ磬ĳͻѾ绰ϵӦѸ磬ĳͻ֤ʵѾƷƻʱƻǵĲƷӦѷ");
        return tipsobject;
    }

    /**
     * Ͽͻάϵͳ
     *
     * @return
     */
    public JSONObject createTips18() {
        tipsobject.put("Դ", "¼");
        tipsobject.put("ؼ", "ǵøϿͻ绰ף");
        tipsobject.put("ͼƬ", "ϿͻΪݣͻÿգϿͻάϵͳϵͳʾѣͼеϿͻ绰ף");
        tipsobject.put("ų", "");
        tipsobject.put("Բο", "ϽϵͼеϿͻףտ֣磬ĳͻѾףӦѵ绰ף");
        return tipsobject;
    }

    /**
     * Ͽͻάϵͳ
     *
     * @return
     */
    public JSONObject createTips19() {
        tipsobject.put("Դ", "¼");
        tipsobject.put("ؼ", "ͻƷյˣǵøϿͻ绰ط");
        tipsobject.put("ͼƬ", "ϿͻΪݣÿʱ䣬ϿͻάϵͳϵͳʾѣͼеϿͻ绰е绰ط÷");
        tipsobject.put("ų", "");
        tipsobject.put("Բο", "ϽϵͼеϿͻе绰ط÷񣬼磬ĳͻѾ绰طãӦѵ绰طá");
        return tipsobject;
    }

    /**
     * ˵ʷ
     *
     * @return
     */
    public JSONObject createTips8() {
        if (datarows.size() > 0) {
            Row lastrow = datarows.getLastRow();
            int freturncount = lastrow.getInteger("freturncount");
            if (freturncount > 0) {
                String siteid = lastrow.getString("siteid");
                String tagentsid = lastrow.getString("tagentsid");
                String fmonth = lastrow.getString("fmonth");
                DBConnect dbConnect = new DBConnect();
                Rows rows = dbConnect.runSqlQuery("select top(1)fchannel from tcustomer_reception where fstatus='˵' and fchannel!='' and CONVERT(varchar(7),fdate,120)='" + fmonth + "' and siteid='" + siteid + "' and tagentsid='" + tagentsid + "' group by fchannel order by count(fchannel) desc");
                if (!rows.isEmpty()) {
                    String fchannel = rows.get(0).getString("fchannel");
                    tipsobject.put("Դ", "¼");
                    tipsobject.put("ؼ", "˵Ҫ" + fchannel + "  Ľ");
                    tipsobject.put("ͼƬ", "˵");
                    tipsobject.put("ų", "˵ο");
                    tipsobject.put("Բο", "˵ҪԴ" + fchannel + "Ľ´ٳ˵");
                }
            }
        }
        return tipsobject;
    }

    /**
     * 
     *
     * @return
     */
    public JSONObject createTips9() {
        if (datarows.size() > 0) {
            tipsobject.put("Դ", "¼");
            tipsobject.put("ؼ", "ע3ά ԸĽ");
            tipsobject.put("ͼƬ", "ע3άȣֱΪССƽ͵ֵ");
            tipsobject.put("ų", "");
            tipsobject.put("Բο", "ΪעάȣŻĽ1⣬Լǿ2Сƫ٣3Сƽ͵ֵƫͣ");
        }
        return tipsobject;
    }

    /**
     * ¼ռȷ
     *
     * @return
     */
    public JSONObject createTips10() {
        if (datarows.size() > 0) {
            tipsobject.put("ؼ", "ۼƿչ" + datarows.size() + "¼");
            tipsobject.put("Բο", "ۼƿչ" + datarows.size() + "¼¼ܽᡢȡ´ͻƣ");
        } else {
            tipsobject.put("ؼ", "ȿŲУ뿪չ¼");
            tipsobject.put("Բο", "û¼ȿŲУ뿪չ¼");
        }
        tipsobject.put("ͼƬ", "2άȣû¼Լͳ¼");
        tipsobject.put("Դ", "¼¼");
        tipsobject.put("ų", "");
        return tipsobject;
    }

    /**
     * ¶÷
     *
     * @return
     */
    public JSONObject createTips11() {
        ArrayList<Row> fcostnameList = new ArrayList<>();
        for (Row datarow : datarows) {
            if (!",ˮ,,н".contains(datarow.getString("fcostname"))) {
                fcostnameList.add(datarow);
            }
        }
        if (fcostnameList.size() >= 2) {
            String fcostname = fcostnameList.get(0).getString("fcostname");
            tipsobject.put("Դ", "¼");
            tipsobject.put("ؼ", "ע" + fcostname + " ");
            tipsobject.put("ͼƬ", "עռߵ1");
            tipsobject.put("ų", "ˮ硢⡢нʣڸ̶ãΪο");
            tipsobject.put("Բο", fcostname + "ռǷҪпƣ磬ΧڵķãԺ");
        }
        return tipsobject;
    }

    /**
     * ¶ӯ
     *
     * @return
     */
    public JSONObject createTips12() {
        if (datarows.size() >= 2) {
            double famount1 = datarows.get(datarows.size() - 1).getDouble("famount");
            double famount2 = datarows.get(datarows.size() - 2).getDouble("famount");
            if (famount1 < 0) {
                tipsobject.put("ؼ", "Ͻֹ");
                tipsobject.put("Բο", "µĿ͵ֵͬŬ");
            } else if (famount1 > famount2) {
                tipsobject.put("ؼ", "ӯͬ");
                tipsobject.put("Բο", "״̬ӯ¶Աˣ֣ͣ");
            } else {
                tipsobject.put("ؼ", "ӯͬ»");
                tipsobject.put("Բο", "״̬ӯ¶Ա»ˣŬ");
            }
            tipsobject.put("Դ", "¼");
            tipsobject.put("ͼƬ", "ӯѣӯ½жԱ");
            tipsobject.put("ų", "״̬½жԱ");
        }
        return tipsobject;
    }

    /**
     * ϿͻϢ
     *
     * @return
     */
    public JSONObject createTips13() {
        if (datarows.size() > 0) {
            tipsobject.put("Դ", "¼");
            tipsobject.put("ؼ", "Ͽͻһϵ");
            tipsobject.put("ͼƬ", "пͻгϵ");
            tipsobject.put("ų", "");
            tipsobject.put("Բο", "ŵ꣬60%ϵĶϿͻܣϿͻÿ̵ҵԱطáϵһ꿪չ1εϿͻ");
        }
        return tipsobject;
    }

    /**
     * ͻϢ
     *
     * @return
     */
    public JSONObject createTips14() {
        if (datarows.size() > 0) {
            tipsobject.put("Դ", "Ӵ¼");
            tipsobject.put("ؼ", "ͻһҪ");
            tipsobject.put("ͼƬ", "ͻгм¼нӴ");
            tipsobject.put("ų", "");
            tipsobject.put("Բο", "ͻӴ2~3λδɽĿͻͨ¼ķʽͻгɽ뱬");
        }
        return tipsobject;
    }


    /**
     * ɽӴռ
     *
     * @return
     */
    public JSONObject createTips15() {
        if (datarows.size() > 0) {
            double fcount = datarows.sum("fcount");
            if (fcount > 0) {
                double freceptiontimes_first = datarows.sum("freceptiontimes_first");
                int average = new Double(Math.ceil(freceptiontimes_first / fcount)).intValue();
                tipsobject.put("Դ", "Ͽͻ");
                tipsobject.put("ؼ", "ƽӴ" + average + "γɽܷ" + (average - 1) + "γɽ");
                tipsobject.put("ͼƬ", "ϿͻгɽͻӴƽֵ");
                tipsobject.put("ų", "");
                tipsobject.put("Բο", "ƽӴ" + average + "γɽܷ" + (average - 1) + "γɽȻѶȣͨĳɳһ");
            }
        }
        return tipsobject;
    }
}
